<?php
/*	$Id: incupdate.php,v 2.00 2004/08/25 14:21:00 fred Exp $	*/

if (!$inbrowser)
	error_reporting(E_ALL);

# Function to upgrade the database schema
function schema_update($schema_file) {
global $db, $lang, $inbrowser, $eoln, $table_prefix;

	if (($sfh = fopen($schema_file, 'r')) === false ) {
		printf($lang['IMPORTMISSINGSCHEMA'].$eoln, $schema_file);
		exit;
	}
// This code assumes that comments are only designated by #, and that # doesn't appear in quotes in a line ...

	$dosub = ($table_prefix != 'DVDPROFILER_');
	$cmd = '';
	while ($line=fgets($sfh)) {
		$temp = explode('#', $line);
		if ($temp[0] != '') {
			$tmp = trim($temp[0]);
			$cmd .= $tmp;
			if (substr($tmp, strlen($tmp)-1, 1) == ';') {
				if ($dosub) $cmd = str_replace('DVDPROFILER_', $table_prefix, $cmd);
				$res = $db->sql_query($cmd) or die($db->sql_error());
				if (is_resource($res)) $db->sql_freeresult($res);
				$cmd = '';
			}
		}
	}
	fclose($sfh);
}

function CheckForCompleteXML($data) {
	$retval = '';
	$Sections['Locks'] = isset($data['LOCKS'][0]);
	$Sections['Cast'] = isset($data['ACTORS'][0]);
	$Sections['Crew'] = isset($data['CREDITS'][0]);
	$Sections['Overview'] = isset($data['OVERVIEW'][0]);
	$Sections['Notes'] = isset($data['NOTES'][0]);
	$Sections['Tags'] = isset($data['TAGS'][0]);
	$Sections['Easter Eggs'] = isset($data['EASTEREGGS'][0]);
	foreach ($Sections as $key => $val)
		if (!$val)
			$retval .= "$key ";
	return($retval);
}

function HandleOutOfDateSchema(&$outputbuffer) {
global $lang, $WeCannotContinue, $inbrowser;

	$outputbuffer = '';
	if (!$WeCannotContinue)
		return;
	$schema_file = 'schema.pre-4.1.sql';
	if (($ver=MySQLVersion()) !== false) {
		list($major, $minor, $patch) = explode('.', $ver);
		if ($major > 4 || ($major == 4 && $minor >= 1)) {
			$schema_file = 'schema.sql';
		}
	}
	if ($inbrowser) {
		$outputbuffer = "$lang[IMPORTBADSCHEMA6]";
		schema_update($schema_file);
		$outputbuffer .= " $lang[IMPORTBADSCHEMA7]";
	}
	else {
		$outputbuffer = html_entity_decode("$lang[IMPORTBADSCHEMA6]\n");
		schema_update($schema_file);
		$outputbuffer .= html_entity_decode("$lang[IMPORTBADSCHEMA7]\n");
	}
}

function TranslateDateTime($string) {
// On entry, $string looks like: 1997-02-24T23:45:52.000Z
// MySQL seems to like: 1997-02-24 23:45:52

	$halves = explode('T', $string);
	if (!isset($halves[1])) $halves[1] = '00:00:00';
	return($halves[0] . ' ' . substr($halves[1], 0, 8));
}

class BufferedInsert {
var $db;
var $max_packet;
var $table;
var $sql;
var $room_left;
var $col_names;

	function BufferedInsert(&$db, $max_packet, $table, $col_names) {
		$this->db = $db;
		$this->room_left = $this->max_packet = $max_packet;
		$this->table = $table;
		$this->col_names = $col_names;
		$this->sql = '';
	}

	function add_element($values) {
		$retval = 0;
		$templen = strlen($values);
		if ($this->room_left <= $templen) {
			$this->db->sql_query($this->sql) or die($this->db->sql_error());
			$this->sql = '';
			$this->room_left = $this->max_packet;
			$retval = 1;
		}
		if ($this->sql == '') {
			$this->sql = "INSERT INTO $this->table $this->col_names VALUES $values";
			$this->room_left -= strlen($this->sql);
		}
		else {
			$this->sql .= ',' . $values;
			$this->room_left -= 1 + $templen;
		}
		return($retval);
	}

	function flush() {
		if ($this->sql != '') {
			$this->db->sql_query($this->sql) or die($this->db->sql_error());
			return(1);
		}
		return(0);
	}
}

$MadeAChange = false;
$max_packet = 1024;	// Initialise global value

/*
//	Functions
*/

// Displays shortened information about an array
// From http://www.devdump.com/phpxml.php
function print_a($obj) {
global $__level_deep;

	if (!isset($__level_deep)) $__level_deep = array();
	if (is_object($obj))
		print '[obj]';
	elseif (is_array($obj)) {
		foreach(array_keys($obj) as $keys) {
			array_push($__level_deep, "[$keys]");
			print_a($obj[$keys]);
			array_pop($__level_deep);
		}
	}
	else
		print implode(' ', $__level_deep)." = $obj\n";
}

// Modified from http://www.devdump.com/phpxml.php
$lineno=0; $addlineno=false;
function GetChildren($vals, &$i) {
global $lineno, $addlineno;

	$children = array();		 // Contains node data

	/* Node has CDATA before it's children */
	if (isset($vals[$i]['value'])) {
		$children['VALUE'] = $vals[$i]['value'];
	}

	/* Loop through children */
	while (++$i < count($vals)) {
		switch ($vals[$i]['type']) {
			/* Node has CDATA after one of it's children
				(Add to cdata found before if this is the case) */
			case 'cdata':
				if (isset($children['VALUE']))
					$children['VALUE'] .= $vals[$i]['value'];
				else
					$children['VALUE'] = $vals[$i]['value'];
				break;
			/* At end of current branch */
			case 'complete':
				if (isset($vals[$i]['attributes'])) {
					$children[$vals[$i]['tag']][]['ATTRIBUTES'] = $vals[$i]['attributes'];
					$index = count($children[$vals[$i]['tag']])-1;
					if ($addlineno) {
						$children[$vals[$i]['tag']][$index]['LINENO'] = $lineno;
						$lineno++;
					}
					if (isset($vals[$i]['value']))
						$children[$vals[$i]['tag']][$index]['VALUE'] = $vals[$i]['value'];
					else
						$children[$vals[$i]['tag']][$index]['VALUE'] = '';
				}
				else {
					if (isset($vals[$i]['value']))
						$children[$vals[$i]['tag']][]['VALUE'] = $vals[$i]['value'];
					else
						$children[$vals[$i]['tag']][]['VALUE'] = '';
					if ($addlineno) {
						$index = count($children[$vals[$i]['tag']])-1;
						$children[$vals[$i]['tag']][$index]['LINENO'] = $lineno;
						$lineno++;
					}
				}
				break;
			/* Node has more children */
			case 'open':
				if (($vals[$i]['tag'] == 'ACTORS') || ($vals[$i]['tag'] == 'CREDITS')) {
					$addlineno = true;
					$lineno = 0;
				}
				if (isset($vals[$i]['attributes'])) {
					$children[$vals[$i]['tag']][]['ATTRIBUTES'] = $vals[$i]['attributes'];
					$index = count($children[$vals[$i]['tag']])-1;
					$children[$vals[$i]['tag']][$index] = array_merge($children[$vals[$i]['tag']][$index],GetChildren($vals, $i));
				}
				else {
					$children[$vals[$i]['tag']][] = GetChildren($vals, $i);
				}
				break;
			/* End of node, return collected data */
			case 'close':
				if (($vals[$i]['tag'] == 'ACTORS') || ($vals[$i]['tag'] == 'CREDITS')) {
					$addlineno = false;
				}
				return $children;
		}
	}
}

function GetXMLTreeFromString($data) {
global $inbrowser, $lang;

        $data = '<?xml version="1.0" encoding="ISO-8859-1"?>' . "\n" . $data; // for php5
	$parser = xml_parser_create('ISO-8859-1');
	xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, true);
	xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, false);
	$retval = xml_parse_into_struct($parser, $data, $vals, $index);
	if ($retval == 0) { // value returned is integer not boolean
	global $amt_on_either_side;
		$err = xml_get_error_code($parser);
		$where_exactly = xml_get_current_byte_index($parser);
		preg_match('|<Title>([^<]*)</Title>|', $data, $matches);
		$title = $matches[1];
		preg_match('|<([^>]*)>|', strrchr(substr($data, 0, $where_exactly), '<'), $matches);
		$tag = $matches[1];
		if ($inbrowser)
			echo "<pre>\n";
		printf($lang['IMPORTBADXML1'], $title, $tag);
		printf($lang['IMPORTBADXML2'], $err, xml_error_string($err));
		printf($lang['IMPORTBADXML3'], $where_exactly, xml_get_current_line_number($parser));
		printf($lang['IMPORTBADXML4'], xml_get_current_column_number($parser), $amt_on_either_side);
		$start = $where_exactly - $amt_on_either_side;
		if ($start < 0) $start = 0;
		echo hexdump(substr($data, $start, $where_exactly-$start), $where_exactly-$start, '     ');
		echo hexdump($data{$where_exactly}, 1, '===> ');
		echo hexdump(substr($data, $where_exactly+1, $amt_on_either_side), $amt_on_either_side, '     ');
		echo $lang['IMPORTBADXML5'];
		if ($inbrowser) {
			print_r(htmlspecialchars($data));
			echo "</pre>\n\n";
		}
		else
			print_r($data);
		exit;
	}
	xml_parser_free($parser);

	$tree = array();
	$i = 0;
	if (isset($vals[$i]['attributes']))
		$tree[$vals[$i]['tag']]['ATTRIBUTES'] = $vals[$i]['attributes'];
	$tree[$vals[$i]['tag']][] = GetChildren($vals, $i);

	unset($vals);
	unset($index);
//print_r($tree);
	return($tree);
}

function UpdateCommonTableFromMemory(&$common_memory, &$common_stats, $table, $hints=false) {
global $db, $eoln, $max_packet, $lang;

	$t0 = microtime_float();
	if ($common_memory != '' ) {
		$col_names = '(caid,firstname,middlename,lastname,birthyear,fullname)';
		$bi = new BufferedInsert($db, $max_packet, $table, $col_names);
		if (!is_array($hints)) {
			foreach ($common_memory as $key => $adata) {
				list($caid, $add) = $adata;
				if ($add == 1) {
					$common_memory[$key] = array($caid, 0);
					$common_stats['numadded']++;

					list($fn, $mn, $ln, $by) = explode('|', $key);
					$toadd =  '('
						.       $caid                                                         . ','
						. "'" . $db->sql_escape($fn)                                          . "',"
						. "'" . $db->sql_escape($mn)                                          . "',"
						. "'" . $db->sql_escape($ln)                                          . "',"
						.       $by                                                           . ','
						. "'" . $db->sql_escape(preg_replace('/\s\s+/', ' ', trim("$fn $mn $ln"))) . "'"
						. ')';

					$common_stats['numinserted'] += $bi->add_element($toadd);
				}
			}
		}
		else {
			foreach ($hints as $key => $whichone) {
				list($caid, $add) = $common_memory[$whichone];
				$common_memory[$whichone] = array($caid, 0);
				$common_stats['numadded']++;

				list($fn, $mn, $ln, $by) = explode('|', $whichone);
				$toadd =  '('
					.       $caid                                                         . ','
					. "'" . $db->sql_escape($fn)                                          . "',"
					. "'" . $db->sql_escape($mn)                                          . "',"
					. "'" . $db->sql_escape($ln)                                          . "',"
					.       $by                                                           . ','
					. "'" . $db->sql_escape(preg_replace('/\s\s+/', ' ', trim("$fn $mn $ln"))) . "'"
					. ')';

				$common_stats['numinserted'] += $bi->add_element($toadd);
			}
		}

		$common_stats['numinserted'] += $bi->flush();
		unset($bi);
		unset($credit);
	}
	$common_stats['amttime'] += microtime_float() - $t0;
}

function InitialiseCommonTable($which) {
global $db_fast_update, $common_actor, $common_actor_stats, $common_credit, $common_credit_stats, $db;
global $DVD_COMMON_ACTOR_TABLE, $DVD_COMMON_CREDITS_TABLE;

	if ($db_fast_update) {
		if ($which == 'common_actor' && $common_actor == '') {
			$res = $db->sql_query("SELECT * FROM $DVD_COMMON_ACTOR_TABLE ORDER BY caid") or die($db->sql_error());
			$key = '';
			while ($row = $db->sql_fetch_array($res)) {
				$key = "$row[firstname]|$row[middlename]|$row[lastname]|$row[birthyear]";
				$common_actor[$key] = array($row['caid'], 0);
			}
			$db->sql_freeresult($res);
			if ($key != '')
				$common_actor_stats['maxid'] = $common_actor[$key][0];
		}

		if ($which == 'common_credit' && $common_credit == '') {
			$res = $db->sql_query("SELECT * FROM $DVD_COMMON_CREDITS_TABLE ORDER BY caid") or die($db->sql_error());
			$key = '';
			while ($row = $db->sql_fetch_array($res)) {
				$key = "$row[firstname]|$row[middlename]|$row[lastname]|$row[birthyear]";
				$common_credit[$key] = array($row['caid'], 0);
			}
			$db->sql_freeresult($res);
			if ($key != '')
				$common_credit_stats['maxid'] = $common_credit[$key][0];
		}
	}
}

function TrueFalse(&$str) {
	return((strtolower($str) == 'true') ? 1 : 0);
}

function GetHashs(&$oldhashs) {
global $db, $DVD_TABLE;

	$result = $db->sql_query("SELECT id,hashprofile,hashnocolid,hashcast,hashcrew FROM $DVD_TABLE") or die($db->sql_error());
	while ($row = $db->sql_fetchrow($result)) {
		$id = array_shift($row);
		$oldhashs[$id] = $row;
	}
	$db->sql_freeresult($result);
	unset($row);
}

function HashData(&$data) {

	$colid = '';
	$hashprofile = Hex(crc32($data));
	$hashnocolid = $hashcast = $hashcrew = $hashprofile;

	if (($back = strpos($data, '</CollectionNumber>')) !== false) {
		$front = strpos($data, '<CollectionNumber>') + strlen('<CollectionNumber>');
		$colid = substr($data, $front, $back-$front);
		$hashnocolid = Hex(crc32(substr($data, 0, $front).substr($data, $back)));
	}

	if (($back = strpos($data, '</Actors>')) !== false) {
		$front = strpos($data, '<Actors>') + strlen('<Actors>');
		$hashcast = Hex(crc32(substr($data, $front, $back-$front)));
	}

	if (($back = strpos($data, '</Credits>')) !== false) {
		$front = strpos($data, '<Credits>') + strlen('<Credits>');
		$hashcrew = Hex(crc32(substr($data, $front, $back-$front)));
	}

	return(array('hashprofile' => $hashprofile, 'hashnocolid' => $hashnocolid, 'hashcast' => $hashcast, 'hashcrew' => $hashcrew, 'colid' => $colid));
}

function ProcessXMLCollection($prelim_output) {
global $xmldir, $xmlfile, $inbrowser, $lang, $eoln, $PHP_SELF, $db, $DVD_TABLE, $delete, $FixBadXML, $thumbnails;
global $forumuser, $handleadult, $collectionurl, $debugimageuploads, $endbody, $remove_missing, $TryToChangeMemoryAndTimeLimits;
global $getimages, $DVD_PROPERTIES_TABLE, $DVD_COMMON_ACTOR_TABLE, $DVD_COMMON_CREDITS_TABLE, $CustomPostUpdate;
global $common_actor, $common_actor_stats, $common_credit, $common_credit_stats, $db_fast_update, $max_packet, $displayfreq;

	$common_actor = $common_credit = '';
	$common_actor_stats = array('maxid' => 1, 'numadded' => 0, 'numinserted' => 0, 'amttime' => (float)0);
	$common_credit_stats = array('maxid' => 1, 'numadded' => 0, 'numinserted' => 0, 'amttime' => (float)0);
	if (!isset($db_fast_update))
		$db_fast_update = false;

	$safe_mode = (bool)@ini_get('safe_mode');
	$TryToChangeMemoryAndTimeLimits	= $TryToChangeMemoryAndTimeLimits && !$safe_mode;
	if ($TryToChangeMemoryAndTimeLimits) @ini_set('memory_limit', -1);	// the import script can use boatloads of memory ...
	if ($inbrowser) {
		header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
		header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
		header('Cache-Control: no-store, no-cache, must-revalidate');
		header('Cache-Control: post-check=0, pre-check=0', false);
		header('Pragma: no-cache');
		header('Content-type: text/html; charset="windows-1252";');
		echo<<<EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=windows-1252">
<title>$lang[IMPORTTITLE]</title>
<link rel="stylesheet" type="text/css" href="format.css.php">
</head>
<body class=f6>
EOT;
	}
	else {
		foreach ($lang as $key => $val) {
			if (substr($key, 0, 6) == 'IMPORT')
				$lang[$key] = html_entity_decode($lang[$key]);
		}
	}

	if ($xmldir == '') {
		if (!is_readable($xmlfile)) {
			if (file_exists($xmlfile)) {
				printf($lang['IMPORTNOXML1']. $eoln, $xmlfile, $eoln);
				exit;
			}
			$CaseInSensitive = file_exists('InDeX.PhP');
			if (!$CaseInSensitive) {
				$dir = dirname($xmlfile);
				$base = basename($xmlfile);
				$MaybeThisOne = findfilecase($dir, $base);
				if ($MaybeThisOne != '') {
					if ($dir != '.') $MaybeThisOne = "$dir/$MaybeThisOne";
					printf($lang['IMPORTNOXML2'].$eoln, $xmlfile);
					printf($lang['IMPORTNOXML3'].$eoln, $MaybeThisOne);
					echo $lang['IMPORTNOXML4'].$eoln;
					echo "\$xmlfile = '$MaybeThisOne';", $eoln;
					exit;
				}
			}
			printf($lang['IMPORTNOXML2'].$eoln, $xmlfile);
			exit;
		}
	}

	$allxmlfiles = array();
	if (is_readable($xmlfile))
		$allxmlfiles[] = $xmlfile;
	if (is_dir($xmldir)) {
		$handle = opendir($xmldir);
		while (($file=readdir($handle)) !== false) {
			if ($file == '.' || $file == '..')
				continue;
			if (is_readable("$xmldir/$file"))
				$allxmlfiles[] = "$xmldir/$file";
		}
		closedir($handle);
	}
	$numxmlfiles = count($allxmlfiles);

	echo $prelim_output, $eoln;
	echo $lang['DBFAST'],($db_fast_update)? $lang['ON']: $lang['OFF'],$eoln;
	flush();
	@ob_flush();
	list($major, $minor) = explode('.', phpversion());
	if ($major > '4' || ($major == '4' && $minor >= '3')) {
		function my_fgets($fh) { return(fgets($fh)); }
	}
	else {	// testing indicates that 256 optimises for speed. it may not always be best ...
		function my_fgets($fh) { return(fgets($fh, 256)); }
	}

// Find out how long a query we can send to the server ...
	$result = $db->sql_query("SHOW VARIABLES like 'max_allowed_packet'") or die($db->sql_error());
	$row = $db->sql_fetch_array($result);
	$db->sql_freeresult($result);
	$max_packet = $row['Value'];
	unset($row);

	$start = microtime_float();

// Delete contents of tables
	if ($delete == 1) {
		echo "$lang[COMPLETE]$eoln";
		flush();
		@ob_flush();
		DeleteFromTables('clean out all of the tables');
	}
	if (!$remove_missing) {
		echo "$lang[NOTREMOVING]$eoln";
		flush();
		@ob_flush();
	}

	$oldhashs = array();
	GetHashs($oldhashs);

	$total = 0;
	$added = 0;
	$removed = 0;
	$changed = 0;
	$newcollnum = 0;
	$ppdelete = 0;

	ModifyTables('DISABLE');
	echo $lang['IMPORTUPDATING'], $eoln;
	if (is_readable($xmlfile)) {
		echo $lang['IMPORTUPDATINGFROM'], $xmlfile, $eoln;
		if ($xmldir != '') {
			printf($lang['IMPORTXMLDIR'], $numxmlfiles-1, $xmldir, $eoln);
		}
	}
	else {
		printf($lang['IMPORTXMLDIR'], $numxmlfiles, $xmldir, $eoln);
	}
	foreach ($allxmlfiles as $key => $currentxmlfile) {
		if (($fh=fopen($currentxmlfile, 'r')) === false) {
			echo $lang['IMPORTBADOPEN'], $currentxmlfile, $eoln;
			if ($inbrowser)
				echo "$endbody</html>\n";
			exit;
		}
		echo "$lang[IMPORTPROCESSING]$currentxmlfile$eoln";

		while (true) {
			do {
				if (($temp=my_fgets($fh)) === false)
					break 2;	// escape the while (true)
			} while (strpos($temp, '<DVD>') === false);
			$data = $temp;
			do {
				if (($temp=my_fgets($fh)) === false)
					break 2;	// escape the while (true)
				$data .= $temp;
			} while (!((!(strpos($data, '</MediaTypes>') === false)) && !(strpos($temp, '</DVD>') === false)));
			$total++;

			$idfront = strpos($data, '<ID>') + strlen('<ID>');
			$idend = strpos($data, '</ID>');
			$id = substr($data, $idfront, $idend-$idfront);
			$hashs = HashData($data);

			if (!isset($oldhashs[$id]) || $hashs['hashprofile'] != $oldhashs[$id]['hashprofile']) {
				if (!isset($oldhashs[$id])) {
					$added++;
					$oldhashs[$id] = array('hashprofile' => '', 'hashnocolid' => '', 'hashcast' => '', 'hashcrew' => '');
				}
				else {
					$changed++;
				}
				if ($oldhashs[$id]['hashnocolid'] == $hashs['hashnocolid']) {
// Only the collection number changed. Update to new id, and walk away.
					$db->sql_query("UPDATE $DVD_TABLE SET collectionnumber='$hashs[colid]',hashprofile='$hashs[hashprofile]' WHERE id='$id'") or die($db->sql_error());
					$newcollnum++;
				}
				else {
// This *resets* the time limit to infinity. that is why it is in the loop
					if ($TryToChangeMemoryAndTimeLimits) @set_time_limit(0);

					$tree = GetXMLTreeFromString($data);
					unset($data);		// trying to reduce memory footprint
					if ($total == 1) {
						$missing = CheckForCompleteXML($tree['DVD'][0]);
						if ($missing != '') {
							echo $currentxmlfile, $lang['IMPORTMISSING1'], $eoln;
							echo $lang['IMPORTMISSING2'], $eoln;
							echo $lang['IMPORTMISSING3'], $missing, $eoln;
							flush();
							@ob_flush();
						}
					}
					$IDsChanged[$tree['DVD'][0]['ID'][0]['VALUE']] = 1;

					$retval = AddADVD($tree['DVD'][0], $hashs, $oldhashs[$id]);
					unset($tree);
					if ($retval != 0) {
						echo $lang['ADDERRORS'][$retval], $total, $eoln;
					}
				}
			}
			if (isset($data)) unset($data);
			if (isset($oldhashs[$id])) unset($oldhashs[$id]);
			if (($total % $displayfreq) == 0) {
				echo $lang['IMPORTPROCESSED'], $total, $eoln;
				flush();
				@ob_flush();
			}
		}
		fclose($fh);
	}
	if (($total % $displayfreq) != 0) {
		echo $lang['IMPORTPROCESSED'], $total, $eoln;
	}


	if ($remove_missing && isset($oldhashs)) {
		$del = 'DELETE';
		foreach ($oldhashs as $id => $theoldhashs) {
			$removed++;
			$del .= "||$id";
			DeleteFromTables($id);
		}
		unset($theoldhashs);
		unset($oldhashs);
	}

	if ($db_fast_update) {
# Now update the cast and crew

		UpdateCommonTableFromMemory($common_actor, $common_actor_stats, $DVD_COMMON_ACTOR_TABLE);
		echo "$lang[ADDCAST] $common_actor_stats[numadded] items, $common_actor_stats[numinserted] inserts in ",
			number_format($common_actor_stats['amttime'], 3, $lang['MON_DECIMAL_POINT'], $lang['MON_THOUSANDS_SEP'])," seconds$eoln";
		unset($common_actor);

		UpdateCommonTableFromMemory($common_credit, $common_credit_stats, $DVD_COMMON_CREDITS_TABLE);
		echo "$lang[ADDCREW] $common_credit_stats[numadded] items, $common_credit_stats[numinserted] inserts in ",
			number_format($common_credit_stats['amttime'], 3, $lang['MON_DECIMAL_POINT'], $lang['MON_THOUSANDS_SEP'])," seconds$eoln";
		unset($common_credit);
	}

	echo $lang['IMPORTBOXSETS'], $eoln;
	flush();
	@ob_flush();
	UpdateBoxSets();
	ModifyTables('ENABLE');

	$DatabaseTime = microtime_float() - $start;

	echo $lang['IMPORTUPDATESTATS'], $eoln;
	flush();
	@ob_flush();
	UpdateStats($TryToChangeMemoryAndTimeLimits);
	$ppdelete = TidyPurchasePlace();

	$totaltime = microtime_float() - $start;

// Print success message
	echo $lang['IMPORTDONE1'], $total, $eoln;
	echo $lang['IMPORTNUMADDED'], $added, $eoln;
	printf("$lang[IMPORTNUMCHANGED]$eoln", $changed, $newcollnum);
	echo $lang['IMPORTNUMREMOVED'], $removed, $eoln;
	echo $lang['SUPPLIERREMOVED'], $ppdelete, $eoln;
	echo $lang['IMPORTDONE2'], number_format($totaltime, 3, $lang['MON_DECIMAL_POINT'], $lang['MON_THOUSANDS_SEP']),  
		' (',  number_format($DatabaseTime, 3, $lang['MON_DECIMAL_POINT'], $lang['MON_THOUSANDS_SEP']),
		' + ', number_format($totaltime-$DatabaseTime, 3, $lang['MON_DECIMAL_POINT'], $lang['MON_THOUSANDS_SEP']),
		')', $eoln;

	if (is_readable('ws.php')) {
        global $handlewatched, $jpgraphlocation, $profiles, $imagecachedir, $ws_wb, $IsPrivate;
        	$action = 'update';
        	include ('ws.php');
	}

 	if (is_readable('imagedata.php') && $forumuser && $collectionurl && $getimages>0) {
	global $img_physpath, $img_webpath, $img_webpathf, $img_webpathb, $VersionNum, $DVD_LOCKS_TABLE;
 		include ('imagedata.php');
 	}
	unset($IDsChanged);

	$db->sql_query("REPLACE INTO $DVD_PROPERTIES_TABLE SET value='".time()."', property='LastUpdate'") or die($db->sql_error());

	if ($inbrowser)
		echo "<br><br><center><a class=\"URLref\" href=\"$PHP_SELF\">$lang[IMPORTCLICK]</a></center>$endbody</html>\n";

	if (is_readable($CustomPostUpdate)) {
		echo "Executing $CustomPostUpdate\n";
		include($CustomPostUpdate);
	}

//	$values = array();
//	$xyz = dbg_get_profiler_results($values);
//	var_dump($xyz);
//	print_r($values);
}

function TidyPurchasePlace() {
global $db, $DVD_TABLE, $DVD_SUPPLIER_TABLE;
	$ppdelete = 0;
	$suppliers = $db->sql_query("SELECT sid FROM $DVD_SUPPLIER_TABLE") or die($db->sql_error());
 	while ($supplierid = $db->sql_fetchrow($suppliers)) {
		$result = $db->sql_query("SELECT id FROM $DVD_TABLE WHERE purchaseplace = '$supplierid[sid]'") or die($db->sql_error());
		if ( !$db->sql_numrows($result)) {
			$ppdelete++;
			$db->sql_query("DELETE FROM $DVD_SUPPLIER_TABLE where sid = '$supplierid[sid]'") or die($db->sql_error());
		}
	}
	return($ppdelete);
}

function DeleteFromTables($id, $castisbad = true, $crewisbad = true) {
global $db, $DVD_TABLE, $DVD_ACTOR_TABLE, $DVD_EVENTS_TABLE, $DVD_DISCS_TABLE, $DVD_AUDIO_TABLE, $DVD_CREDITS_TABLE, $DVD_LOCKS_TABLE;
global $DVD_BOXSET_TABLE, $DVD_STUDIO_TABLE, $DVD_SUBTITLE_TABLE, $DVD_TAGS_TABLE, $DVD_SUPPLIER_TABLE, $MadeAChange;
global $DVD_GENRES_TABLE, $DVD_COMMON_ACTOR_TABLE, $DVD_COMMON_CREDITS_TABLE;

	$MadeAChange = true;
	$where = '';
	if ($id != 'clean out all of the tables')
		$where = "WHERE id='$id'";
	$db->sql_query("DELETE FROM $DVD_TABLE $where") or die($db->sql_error());
	if ($castisbad) $db->sql_query("DELETE FROM $DVD_ACTOR_TABLE $where") or die($db->sql_error());
	$db->sql_query("DELETE FROM $DVD_EVENTS_TABLE $where") or die($db->sql_error());
	$db->sql_query("DELETE FROM $DVD_LOCKS_TABLE $where") or die($db->sql_error());
	$db->sql_query("DELETE FROM $DVD_DISCS_TABLE $where") or die($db->sql_error());
	$db->sql_query("DELETE FROM $DVD_AUDIO_TABLE $where") or die($db->sql_error());
	$db->sql_query("DELETE FROM $DVD_GENRES_TABLE $where") or die($db->sql_error());
	if ($crewisbad) $db->sql_query("DELETE FROM $DVD_CREDITS_TABLE $where") or die($db->sql_error());
	$db->sql_query("DELETE FROM $DVD_BOXSET_TABLE $where") or die($db->sql_error());
	$db->sql_query("DELETE FROM $DVD_STUDIO_TABLE $where") or die($db->sql_error());
	$db->sql_query("DELETE FROM $DVD_SUBTITLE_TABLE $where") or die($db->sql_error());
	$db->sql_query("DELETE FROM $DVD_TAGS_TABLE $where") or die($db->sql_error());
	if ($where != '') {
		$db->sql_query("UPDATE $DVD_TABLE SET boxparent='' WHERE boxparent='$id'") or die($db->sql_error());
	}
	else {
		$db->sql_query("DELETE FROM $DVD_SUPPLIER_TABLE") or die($db->sql_error());
		$db->sql_query("DELETE FROM $DVD_COMMON_ACTOR_TABLE where caid!=1") or die($db->sql_error());
		$db->sql_query("DELETE FROM $DVD_COMMON_CREDITS_TABLE where caid!=1") or die($db->sql_error());
	}
}

function GetAnIDFor($fname, $mname, $lname, $birth, $table, &$hints) {
global $db, $db_fast_update, $DVD_COMMON_ACTOR_TABLE;
global $common_actor, $common_actor_stats, $common_credit, $common_credit_stats;

	if ($db_fast_update) {
        	$fullname = "$fname|$mname|$lname|$birth";

		if ($table == $DVD_COMMON_ACTOR_TABLE) {
			$common_name = &$common_actor;
			$common_stats = &$common_actor_stats;
		}
		else {
			$common_name = &$common_credit;
			$common_stats = &$common_credit_stats;
		}

        	if (isset($common_name[$fullname])) {
                	list($id, $add) = $common_name[$fullname];
                	return($id);
        	}
		else {
                	$common_stats['maxid']++;
                	$common_name[$fullname] = array($common_stats['maxid'], 1);
			$hints[] = $fullname;
                	return($common_stats['maxid']);
        	}
	}

	$sql = "SELECT * FROM $table WHERE firstname='" . $db->sql_escape($fname)
		."' AND middlename='" . $db->sql_escape($mname)
		."' AND lastname='" . $db->sql_escape($lname)
		."' AND birthyear='" . $db->sql_escape($birth) . "'";
	$res = $db->sql_query($sql) or die($db->sql_error());
	$foundaid = false;
	while ($aid = $db->sql_fetchrow($res)) {
		if ($aid['firstname'] == $fname &&
		    $aid['middlename'] == $mname &&
		    $aid['lastname'] == $lname &&
		    $aid['birthyear'] == $birth) {
			$foundaid = true;
			break;
		}
	}
	$db->sql_freeresult($res);

	if ($foundaid === false) {
		$sql = "INSERT INTO $table (caid,firstname,middlename,lastname,birthyear,fullname) VALUES ("
			.'0,'
			."'" . $db->sql_escape($fname) ."',"
			."'" . $db->sql_escape($mname) ."',"
			."'" . $db->sql_escape($lname) ."',"
			."'" . $db->sql_escape($birth) ."',"
			."'" . $db->sql_escape(preg_replace('/\s\s+/', ' ', trim("$fname $mname $lname"))) . "')";
		$db->sql_query($sql) or die($db->sql_error());
		$aid['caid'] = $db->sql_nextid();
	}
	return($aid['caid']);
}

function StringIfThere(&$str, $default='') {
global $db;
	if (isset($str))
		return($db->sql_escape($str));
	return($default);
}

function AddADVD(&$dvd_info, $hashs, $oldhashs) {
global $DVD_TABLE, $DVD_COMMON_ACTOR_TABLE, $DVD_ACTOR_TABLE, $DVD_EVENTS_TABLE, $DVD_DISCS_TABLE, $DVD_AUDIO_TABLE, $DVD_LOCKS_TABLE;
global $DVD_COMMON_CREDITS_TABLE, $DVD_CREDITS_TABLE, $DVD_BOXSET_TABLE, $DVD_STUDIO_TABLE, $DVD_SUBTITLE_TABLE, $DVD_TAGS_TABLE;
global $DVD_SUPPLIER_TABLE, $DVD_GENRES_TABLE;
global $db, $img_episode, $episode_replacements, $pcre_episode_replacements, $delete, $all_in_one_go;
global $common_actor, $common_actor_stats, $common_credit, $common_credit_stats, $max_packet, $db_fast_update, $lang;

	$TheProfileID = $dvd_info['ID'][0]['VALUE'];
	if ($TheProfileID == '') {
// Profile IDs may not be blank
		return(1);
	}

	if ($delete != 1)	// Don't bother if we've already nuked the entire db ...
		DeleteFromTables($TheProfileID, $hashs['hashcast']!=$oldhashs['hashcast'], $hashs['hashcrew']!=$oldhashs['hashcrew']);

// Prepare some dates
	if (isset($dvd_info['RELEASED'][0]['VALUE'])) {
		if (strstr($dvd_info['RELEASED'][0]['VALUE'], '/'))
			list($release_day, $release_month, $release_year) = explode('/', $dvd_info['RELEASED'][0]['VALUE']);
		else
			list($release_year, $release_month, $release_day) = explode('-', $dvd_info['RELEASED'][0]['VALUE']);
		$released = my_mktime(0, 0, 0, $release_month, $release_day, $release_year);
	}
	else
		$released = 'NULL';

	$purchase_day = $purchase_month = $purchase_year = 0;
	if (isset($dvd_info['PURCHASEINFO'][0]['PURCHASEDATE'][0]['VALUE'])) {
		if (strstr($dvd_info['PURCHASEINFO'][0]['PURCHASEDATE'][0]['VALUE'], '/'))
			list($purchase_day, $purchase_month, $purchase_year) = explode('/', $dvd_info['PURCHASEINFO'][0]['PURCHASEDATE'][0]['VALUE']);
		else
			list($purchase_year, $purchase_month, $purchase_day) = explode('-', $dvd_info['PURCHASEINFO'][0]['PURCHASEDATE'][0]['VALUE']);
	}

	$lastedited_day = $lastedited_month = $lastedited_year = 0;
	if (isset($dvd_info['LASTEDITED'][0]['VALUE'])) {
		if (strstr($dvd_info['LASTEDITED'][0]['VALUE'], '/'))
			list($lastedited_day, $lastedited_month, $lastedited_year) = explode('/', $dvd_info['LASTEDITED'][0]['VALUE']);
		else
			list($lastedited_year, $lastedited_month, $lastedited_day) = explode('-', $dvd_info['LASTEDITED'][0]['VALUE']);
	}

	$loan_day = $loan_month = $loan_year = 0;
	if (isset($dvd_info['LOANINFO'][0]['DUE'][0]['VALUE'])) {
		if (strstr($dvd_info['LOANINFO'][0]['DUE'][0]['VALUE'], '/'))
			list($loan_day, $loan_month, $loan_year) = explode('/', $dvd_info['LOANINFO'][0]['DUE'][0]['VALUE']);
		else
			list($loan_year, $loan_month, $loan_day) = explode('-', $dvd_info['LOANINFO'][0]['DUE'][0]['VALUE']);
	}

	$purchaseprice = (isset($dvd_info['PURCHASEINFO'][0]['PURCHASEPRICE'][0]['ATTRIBUTES']['FORMATTEDVALUE'])) ? $dvd_info['PURCHASEINFO'][0]['PURCHASEPRICE'][0]['ATTRIBUTES']['FORMATTEDVALUE'] : '0';
	$paid = (isset($dvd_info['PURCHASEINFO'][0]['PURCHASEPRICE'][0]['VALUE'])) ? $dvd_info['PURCHASEINFO'][0]['PURCHASEPRICE'][0]['VALUE'] : 0;
	$srp = (isset($dvd_info['SRP'][0]['ATTRIBUTES']['FORMATTEDVALUE'])) ? $dvd_info['SRP'][0]['ATTRIBUTES']['FORMATTEDVALUE'] : '0';
	$srpdec = (isset($dvd_info['SRP'][0]['VALUE'])) ? $dvd_info['SRP'][0]['VALUE'] : 0;

	$collectiontype	= (isset($dvd_info['COLLECTIONTYPE'][0]['VALUE'])) ? strtolower($dvd_info['COLLECTIONTYPE'][0]['VALUE']) : 'owned';

	if ($collectiontype == 'wish list') $collectiontype = 'wishlist';	// 3.0 changed the name ...
// in V3, it's guaranteed that a wishpriority will exist. Sadly, it may not be zero for non-wishlist items. Better fix that ...
	$wishpriority = ($collectiontype=='wishlist') ? intval($dvd_info['WISHPRIORITY'][0]['VALUE']) : 0;

// Make a string of all the regions supported. If nothing, set to 0 for all
	$region = '';
	for ($i=0; $i<9; $i++) {
		if (isset($dvd_info['REGIONS'][0]['REGION'][$i]['VALUE']))
			$region	.= intval($dvd_info['REGIONS'][0]['REGION'][$i]['VALUE']);
	}
	if ($region == '') $region = '0'; // Blank <Regions> tag means Region 0: All

	$caseslipcover = 0;
	if (isset($dvd_info['CASESLIPCOVER'][0]['VALUE']) && TrueFalse($dvd_info['CASESLIPCOVER'][0]['VALUE']))
		$caseslipcover = 1;
// Clean up the aspect ratio. Fix the most common problems NOW STORING DATA INDISCRIMINATELY
	$formataspectratio =  (isset($dvd_info['FORMAT'][0]['FORMATASPECTRATIO'][0]['VALUE'])) ? $dvd_info['FORMAT'][0]['FORMATASPECTRATIO'][0]['VALUE'] : '';

	$format16x9 = TrueFalse($dvd_info['FORMAT'][0]['FORMAT16X9'][0]['VALUE']);
	$formatletterbox = TrueFalse($dvd_info['FORMAT'][0]['FORMATLETTERBOX'][0]['VALUE']);

// Process the notes field for episode guides. This assumes that the images will be
// referenced by the strings in the $episode_replacements array
	$notes = (isset($dvd_info['NOTES'][0]['VALUE'])) ? $dvd_info['NOTES'][0]['VALUE'] : '';
	foreach ($pcre_episode_replacements as $val => $repl)
		$notes = preg_replace($repl, $img_episode, $notes);
	foreach ($episode_replacements as $val => $repl)
		$notes = str_replace($repl, $img_episode, $notes);

// Put purchase place/url/type in its only table and store just the purchaseplace id in the dvd table.

        $sid = '';
	$suppliername = '';
	if ($collectiontype != 'wishlist')
		$suppliername = (isset($dvd_info['PURCHASEINFO'][0]['PURCHASEPLACE'][0]['VALUE'])) ? $dvd_info['PURCHASEINFO'][0]['PURCHASEPLACE'][0]['VALUE'] : '';
	if ( $suppliername ) {
		$supplier = array(
			'suppliername' =>  $suppliername,
			'suppliertype' => (isset($dvd_info['PURCHASEINFO'][0]['PURCHASEPLACETYPE'][0]['VALUE'])) ? $dvd_info['PURCHASEINFO'][0]['PURCHASEPLACETYPE'][0]['VALUE'] : '',
			'supplierurl' => (isset($dvd_info['PURCHASEINFO'][0]['PURCHASEPLACEWEBSITE'][0]['VALUE'])) ? $dvd_info['PURCHASEINFO'][0]['PURCHASEPLACEWEBSITE'][0]['VALUE'] : ''
		);
	}
	else {
		$suppliername = 'Unknown';
		$supplier = array(
			'suppliername' => 'Unknown',
			'suppliertype' => 'U',
			'supplierurl' => ''
		);
	}

       	while ( !$sid ) {
               	$xxx = "SELECT sid FROM $DVD_SUPPLIER_TABLE WHERE suppliername='" . $db->sql_escape($suppliername) . "'";
               	$result = $db->sql_query($xxx) or die($db->sql_error());
               	$row = $db->sql_fetchrow($result);
               	$sid = $row['sid'];
               	if ( !$sid ) {
                       	$sql = "INSERT INTO $DVD_SUPPLIER_TABLE " . $db->sql_build_array('INSERT', $supplier);
                       	$db->sql_query($sql) or die($db->sql_error());
               	}
       	}
       	unset ($supplier);

	$auxcolltype = '';
	if (isset($dvd_info['TAGS'][0]['TAG'])) {
		$sql = '';
		foreach ($dvd_info['TAGS'][0]['TAG'] as $num_s => $tag_info) {
			$n = (isset($tag_info['ATTRIBUTES']['NAME'])) ? $db->sql_escape($tag_info['ATTRIBUTES']['NAME']) : '';
			$f = (isset($tag_info['ATTRIBUTES']['FULLNAME'])) ? $tag_info['ATTRIBUTES']['FULLNAME'] : '';
			if (strncasecmp($f, 'TABS/', strlen('TABS/')) == 0) {
				$z = str_replace(',', '/', substr($f, strlen('TABS/')));
				$auxcolltype .= ",$z";
			}
			if ($f != '') $f = $db->sql_escape($f);
			if ($sql != '') $sql .= ',';
			$sql .= "('$TheProfileID','$n','$f')";
		}
		if ($sql != '')
			$db->sql_query("INSERT INTO $DVD_TAGS_TABLE (id,name,fullyqualifiedname) VALUES $sql") or die($db->sql_error());
		if ($auxcolltype != '')
			$auxcolltype = substr($auxcolltype, 1);
	}

	if (isset($dvd_info['BOXSET'][0]['CONTENTS'][0]['CONTENT'])) {
		$sql = '';
		foreach ($dvd_info['BOXSET'][0]['CONTENTS'][0]['CONTENT'] as $num_s => $boxset_info) {
			$c = (isset($boxset_info['VALUE'])) ? $boxset_info['VALUE'] : '';
			if ($sql != '') $sql .= ',';
			$sql .= "('$TheProfileID','$c')";
		}
		if ($sql != '')
			$db->sql_query("INSERT INTO $DVD_BOXSET_TABLE (id,child) VALUES $sql") or die($db->sql_error());
	}

	$isadulttitle = 0;
	$primegenre = '';
	if (isset($dvd_info['GENRES'][0]['GENRE'])) {
		$sql = '';
		foreach ($dvd_info['GENRES'][0]['GENRE'] as $num_g => $genre_info) {
			if (!empty($genre_info['VALUE'])) {
				if ($primegenre == '')
					$primegenre = $genre_info['VALUE'];
				if ($sql != '') $sql .= ',';
				$sql .= "('$TheProfileID',$num_g,'" . $db->sql_escape($genre_info['VALUE']) . "')";
				if ($genre_info['VALUE'] == 'Adult')
					$isadulttitle = 1;
			}
		}
		if ($sql != '')
			$db->sql_query("INSERT INTO $DVD_GENRES_TABLE (id,dborder,genre) VALUES $sql") or die($db->sql_error());
	}

	if (isset($dvd_info['STUDIOS'][0]['STUDIO'])) {
		$dborder = 0;
		$sql = '';
		foreach ($dvd_info['STUDIOS'][0]['STUDIO'] as $num_s => $studio_info) {
			$dborder++;
			$s = (isset($studio_info['VALUE'])) ? $db->sql_escape($studio_info['VALUE']) : '';
			if ($sql != '') $sql .= ',';
			$sql .= "('$TheProfileID',0,$dborder,'$s')";
		}
		if ($sql != '')
			$db->sql_query("INSERT INTO $DVD_STUDIO_TABLE (id,ismediacompany,dborder,studio) VALUES $sql") or die($db->sql_error());
	}
	if (isset($dvd_info['MEDIACOMPANIES'][0]['MEDIACOMPANY'])) {
		$dborder = 0;
		$sql = '';
		foreach ($dvd_info['MEDIACOMPANIES'][0]['MEDIACOMPANY'] as $num_s => $studio_info) {
			$dborder++;
			$s = (isset($studio_info['VALUE'])) ? $db->sql_escape($studio_info['VALUE']) : '';
			if ($sql != '') $sql .= ',';
			$sql .= "('$TheProfileID',1,$dborder,'$s')";
		}
		if ($sql != '')
			$db->sql_query("INSERT INTO $DVD_STUDIO_TABLE (id,ismediacompany,dborder,studio) VALUES $sql") or die($db->sql_error());
	}
	if (!empty($dvd_info['MEDIAPUBLISHER'][0]['VALUE'])) {
		$db->sql_query("INSERT INTO $DVD_STUDIO_TABLE (id,ismediacompany,dborder,studio) VALUES ('$TheProfileID',1,1,'".$dvd_info['MEDIAPUBLISHER'][0]['VALUE']."')") or die($db->sql_error());
	}

	if (isset($dvd_info['SUBTITLES'][0]['SUBTITLE'])) {
		$dborder = 0;
		$sql = '';
		foreach ($dvd_info['SUBTITLES'][0]['SUBTITLE'] as $num_s => $subtitle_info) {
			$dborder++;
			$s = (isset($subtitle_info['VALUE'])) ? $db->sql_escape($subtitle_info['VALUE']) : '';
			if ($sql != '') $sql .= ',';
			$sql .= "('$TheProfileID',$dborder,'$s')";
		}
		if ($sql != '')
			$db->sql_query("INSERT INTO $DVD_SUBTITLE_TABLE (id,dborder,subtitle) VALUES $sql") or die($db->sql_error());
	}

 	if (isset($dvd_info['EVENTS'][0]['EVENT'])) {
		$sql = '';
 		foreach ($dvd_info['EVENTS'][0]['EVENT'] as $num_s => $event_info) {
 			$f = (isset($event_info['USER'][0]['ATTRIBUTES']['FIRSTNAME'])) ? $db->sql_escape($event_info['USER'][0]['ATTRIBUTES']['FIRSTNAME']) : '';
 			$l = (isset($event_info['USER'][0]['ATTRIBUTES']['LASTNAME'])) ? $db->sql_escape(HideName($event_info['USER'][0]['ATTRIBUTES']['LASTNAME'])) : '';
 			$e = (isset($event_info['USER'][0]['ATTRIBUTES']['EMAILADDRESS'])) ? $db->sql_escape($event_info['USER'][0]['ATTRIBUTES']['EMAILADDRESS']) : '';
 			$p = (isset($event_info['USER'][0]['ATTRIBUTES']['PHONENUMBER'])) ? $db->sql_escape($event_info['USER'][0]['ATTRIBUTES']['PHONENUMBER']) : '';
 			$t = (isset($event_info['EVENTTYPE'][0]['VALUE'])) ? $event_info['EVENTTYPE'][0]['VALUE'] : '';
 			$d = (isset($event_info['TIMESTAMP'][0]['VALUE'])) ? TranslateDateTime($event_info['TIMESTAMP'][0]['VALUE']) : '';
			if ($sql != '') $sql .= ',';
			$sql .= "('$TheProfileID','$f','$l','$e','$p','$t','','$d')"; // The blank is the missing events notes
 		}
		if ($sql != '')
 			$db->sql_query("INSERT INTO $DVD_EVENTS_TABLE (id,firstname,lastname,emailaddress,phonenumber,eventtype,note,timestamp) VALUES $sql") or die($db->sql_error());
 		unset($event);
 	}

	if (isset($dvd_info['AUDIO'][0]['AUDIOTRACK'])) {
		$dborder = 0;
		$sql = '';
		foreach ($dvd_info['AUDIO'][0]['AUDIOTRACK'] as $num_b => $audio_info) {
			$dborder++;
			$c = (isset($audio_info['AUDIOCONTENT'][0]['VALUE'])) ? $db->sql_escape($audio_info['AUDIOCONTENT'][0]['VALUE']) : '';
			$f = (isset($audio_info['AUDIOFORMAT'][0]['VALUE'])) ? $db->sql_escape($audio_info['AUDIOFORMAT'][0]['VALUE']) : '';
			if ($sql != '') $sql .= ',';
			$sql .= "('$TheProfileID',$dborder,'$c','$f')";
		}
		if ($sql != '')
			$db->sql_query("INSERT INTO $DVD_AUDIO_TABLE (id,dborder,audiocontent,audioformat) VALUES $sql") or die($db->sql_error());
	}

	if (isset($dvd_info['DISCS'][0]['DISC'])) {
		$discno = 0;
		$fields  = '(id,discno,discdescsidea,discdescsideb,discidsidea,discidsideb,labelsidea,labelsideb,duallayeredsidea,duallayeredsideb,dualsided,location,slot)';
		$sql = '';
		foreach ($dvd_info['DISCS'][0]['DISC'] as $num_s => $disc_info) {
			if ($sql != '') $sql .= ',';
			$discno++;
			$sql .= "('$TheProfileID'";
			$sql .= ",$discno";
			$sql .= ",'" . StringIfThere($disc_info['DESCRIPTIONSIDEA'][0]['VALUE']) . "'";
			$sql .= ",'" . StringIfThere($disc_info['DESCRIPTIONSIDEB'][0]['VALUE']) . "'";
			$sql .= ",'" . StringIfThere($disc_info['DISCIDSIDEA'][0]['VALUE']) . "'";
			$sql .= ",'" . StringIfThere($disc_info['DISCIDSIDEB'][0]['VALUE']) . "'";
			$sql .= ",'" . StringIfThere($disc_info['LABELSIDEA'][0]['VALUE']) . "'";
			$sql .= ",'" . StringIfThere($disc_info['LABELSIDEB'][0]['VALUE']) . "'";
			$sql .= ','; $sql .= (isset($disc_info['DUALLAYEREDSIDEA'][0]['VALUE'])) ? TrueFalse($disc_info['DUALLAYEREDSIDEA'][0]['VALUE']) : "''";
			$sql .= ','; $sql .= (isset($disc_info['DUALLAYEREDSIDEB'][0]['VALUE'])) ? TrueFalse($disc_info['DUALLAYEREDSIDEB'][0]['VALUE']) : "''";
			$sql .= ','; $sql .= (isset($disc_info['DUALSIDED'][0]['VALUE'])) ? TrueFalse($disc_info['DUALSIDED'][0]['VALUE']) : "''";
			$sql .= ",'" . StringIfThere($disc_info['LOCATION'][0]['VALUE']) . "'";
			$sql .= ",'" . StringIfThere($disc_info['SLOT'][0]['VALUE']) . "'";
			$sql .= ')';

		}
		$db->sql_query("INSERT INTO $DVD_DISCS_TABLE $fields VALUES $sql") or die($db->sql_error());
	}

	if (isset($dvd_info['LOCKS'][0])) {
		$f  = 'id';			$v  =       "'$TheProfileID'";
		$f .= ',entire';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['ENTIRE'][0]['VALUE']);
		$f .= ',covers';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['COVERS'][0]['VALUE']);
		$f .= ',title';			$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['TITLE'][0]['VALUE']);
		$f .= ',mediatype';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['MEDIATYPE'][0]['VALUE']);
		$f .= ',overview';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['OVERVIEW'][0]['VALUE']);
		$f .= ',regions';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['REGIONS'][0]['VALUE']);
		$f .= ',genres';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['GENRES'][0]['VALUE']);
		$f .= ',srp';			$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['SRP'][0]['VALUE']);
		$f .= ',studios';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['STUDIOS'][0]['VALUE']);
		$f .= ',discinfo';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['DISCINFORMATION'][0]['VALUE']);
		$f .= ',cast';			$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['CAST'][0]['VALUE']);
		$f .= ',crew';			$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['CREW'][0]['VALUE']);
		$f .= ',features';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['FEATURES'][0]['VALUE']);
		$f .= ',audio';			$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['AUDIOTRACKS'][0]['VALUE']);
		$f .= ',subtitles';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['SUBTITLES'][0]['VALUE']);
		$f .= ',eastereggs';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['EASTEREGGS'][0]['VALUE']);
		$f .= ',runningtime';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['RUNNINGTIME'][0]['VALUE']);
		$f .= ',releasedate';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['RELEASEDATE'][0]['VALUE']);
		$f .= ',productionyear';	$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['PRODUCTIONYEAR'][0]['VALUE']);
		$f .= ',casetype';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['CASETYPE'][0]['VALUE']);
		$f .= ',videoformats';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['VIDEOFORMATS'][0]['VALUE']);
		$f .= ',rating';		$v .= ',' . TrueFalse($dvd_info['LOCKS'][0]['RATING'][0]['VALUE']);
		$db->sql_query("INSERT INTO $DVD_LOCKS_TABLE ($f) VALUES ($v)") or die($db->sql_error());
	}

	if ($hashs['hashcast'] != $oldhashs['hashcast']) {
// Process Actors into Common name table and create cast list
		InitialiseCommonTable('common_actor');
		$actor = array();
		$hints = false;
		if (!$all_in_one_go)
			$hints = array();
		if (isset($dvd_info['ACTORS'][0]['ACTOR'])) {
//			for ($i=0; $i<2000; $i++) {$linenofound[$i] = 0;}
//			foreach ($dvd_info['ACTORS'][0]['ACTOR'] as $num_a => $actor_info) {
//				if (++$linenofound[$actor_info['LINENO']] != 1) {
//					echo "Duplicate line number found in actors in profile id=$TheProfileID\n";
//					print_r($actor_info);
//					exit;
//				}
//			}
			foreach ($dvd_info['ACTORS'][0]['ACTOR'] as $num_a => $actor_info) {
				$aid = GetAnIDFor(
					$actor_info['ATTRIBUTES']['FIRSTNAME'],
					$actor_info['ATTRIBUTES']['MIDDLENAME'],
					$actor_info['ATTRIBUTES']['LASTNAME'],
					$actor_info['ATTRIBUTES']['BIRTHYEAR'],
					$DVD_COMMON_ACTOR_TABLE,
					$hints
				);
				$actor[] = array(
					'id'		=> $TheProfileID,
					'lineno'	=> $actor_info['LINENO'],
					'caid'		=> $aid,
					'creditedas'	=> $actor_info['ATTRIBUTES']['CREDITEDAS'],
					'role'		=> $actor_info['ATTRIBUTES']['ROLE'],
					'voice'		=> TrueFalse($actor_info['ATTRIBUTES']['VOICE']),
					'uncredited'	=> TrueFalse($actor_info['ATTRIBUTES']['UNCREDITED'])
				);
			}
		}
		if (isset($dvd_info['ACTORS'][0]['DIVIDER'])) {
//			for ($i=0; $i<2000; $i++) {$linenofound[$i] = 0;}
//			foreach ($dvd_info['ACTORS'][0]['DIVIDER'] as $num_a => $actor_info) {
//				if (++$linenofound[$actor_info['LINENO']] != 1) {
//					echo "Duplicate line number found in actors dividers in profile id=$TheProfileID\n";
//					print_r($actor_info);
//					exit;
//				}
//			}
			foreach ($dvd_info['ACTORS'][0]['DIVIDER'] as $num_a => $actor_info) {
				$actor[] = array(
					'id'		=> $TheProfileID,
					'lineno'	=> $actor_info['LINENO'],
					'caid'		=> 1,		// Reserved caid==1 for dividers
					'creditedas'	=> $actor_info['ATTRIBUTES']['CAPTION'],
					'role'		=> '',
					'voice'		=> 0,
					'uncredited'	=> 0
				);
			}
		}
		if (count($actor) != 0) {
			$col_names = '(id,lineno,caid,creditedas,role,voice,uncredited)';
			$bi = new BufferedInsert($db, $max_packet, $DVD_ACTOR_TABLE, $col_names);
			foreach ($actor as $num => $act) {
				$toadd =  '('
					. "'" . $act['id']                          . "',"
					.       $act['lineno']                      . ','
					.       $act['caid']                        . ','
					. "'" . $db->sql_escape($act['creditedas']) . "',"
					. "'" . $db->sql_escape($act['role'])       . "',"
					.       $act['voice']                       . ','
					.       $act['uncredited']
					. ')';
				$bi->add_element($toadd);
			}
			unset($actor);
			$bi->flush();
			unset($bi);
		}
		if ($db_fast_update && !$all_in_one_go && count($hints) != 0) {
			UpdateCommonTableFromMemory($common_actor, $common_actor_stats, $DVD_COMMON_ACTOR_TABLE, $hints);
		}
		unset($hints);
	}	// if hashs don't match

	if ($hashs['hashcrew'] != $oldhashs['hashcrew']) {
// Process Crew into Common name table and create crew list
		InitialiseCommonTable('common_credit');
		$credit = array();
		$hints = false;
		if (!$all_in_one_go)
			$hints = array();
		if (isset($dvd_info['CREDITS'][0]['CREDIT'])) {
//			for ($i=0; $i<2000; $i++) {$linenofound[$i] = 0;}
//			foreach ($dvd_info['CREDITS'][0]['CREDIT'] as $num_a => $actor_info) {
//				if (++$linenofound[$actor_info['LINENO']] != 1) {
//					echo "Duplicate line number found in credits in profile id=$TheProfileID\n";
//					print_r($actor_info);
//					exit;
//				}
//			}
			foreach ($dvd_info['CREDITS'][0]['CREDIT'] as $num_d => $credit_info) {
				$cid = GetAnIDFor(
					$credit_info['ATTRIBUTES']['FIRSTNAME'],
					$credit_info['ATTRIBUTES']['MIDDLENAME'],
					$credit_info['ATTRIBUTES']['LASTNAME'],
					$credit_info['ATTRIBUTES']['BIRTHYEAR'],
					$DVD_COMMON_CREDITS_TABLE,
					$hints
				);
				$credit[] = array(
					'id'		=> $TheProfileID,
					'lineno'	=> $credit_info['LINENO'],
					'caid'		=> $cid,
					'creditedas'	=> $credit_info['ATTRIBUTES']['CREDITEDAS'],
					'credittype'	=> $credit_info['ATTRIBUTES']['CREDITTYPE'],
					'creditsubtype'	=> $credit_info['ATTRIBUTES']['CREDITSUBTYPE'],
					'customrole'	=> (isset($credit_info['ATTRIBUTES']['CUSTOMROLE'])? $credit_info['ATTRIBUTES']['CUSTOMROLE']: '')
				);
			}
		}
		if (isset($dvd_info['CREDITS'][0]['DIVIDER'])) {
//			for ($i=0; $i<2000; $i++) {$linenofound[$i] = 0;}
//			foreach ($dvd_info['CREDITS'][0]['DIVIDER'] as $num_a => $credit_info) {
//				if (++$linenofound[$credit_info['LINENO']] != 1) {
//					echo "Duplicate line number found in credits dividers in profile id=$TheProfileID\n";
//					print_r($credit_info);
//					exit;
//				}
//			}
			foreach ($dvd_info['CREDITS'][0]['DIVIDER'] as $num_a => $credit_info) {
				$credit[] = array(
					'id'		=> $TheProfileID,
					'lineno'	=> $credit_info['LINENO'],
					'caid'		=> 1,		// Reserved caid==1 for dividers
					'creditedas'	=> $credit_info['ATTRIBUTES']['CAPTION'],
					'credittype'	=> '',
					'creditsubtype'	=> '',
					'customrole'	=> ''
				);
			}
		}
		if (count($credit) != 0) {
			$col_names = '(id,lineno,caid,creditedas,credittype,creditsubtype,customrole)';
			$bi = new BufferedInsert($db, $max_packet, $DVD_CREDITS_TABLE, $col_names);
			foreach ($credit as $num => $cred) {
				$toadd =  '('
					. "'" . $cred['id']                             . "',"
					.       $cred['lineno']                         . ','
					.       $cred['caid']                           . ','
					. "'" . $db->sql_escape($cred['creditedas'])    . "',"
					. "'" . $db->sql_escape($cred['credittype'])    . "',"
					. "'" . $db->sql_escape($cred['creditsubtype']) . "',"
					. "'" . $db->sql_escape($cred['customrole'])    . "'"
					. ')';
				$bi->add_element($toadd);
			}
			unset($credit);
			$bi->flush();
			unset($bi);
		}
	
		if ($db_fast_update && !$all_in_one_go && count($hints) != 0) {
			UpdateCommonTableFromMemory($common_credit, $common_credit_stats, $DVD_COMMON_CREDITS_TABLE, $hints);
		}
		unset($hints);
	}	// if hashs don't match

// INSERT into array representing the DB structure
// Do this last, as the $uniqueness key that marks the profile as added is in this table. Thus allowing
// restarts, and preventing partial data corruption.
// The XML contains arbitrary strings (eg. Overview), numbers (eg. formatletterbox) and manifest strings (eg. genre)
// The manifest strings are all in English. They will be put into the database in English, and the translations will
// be done when displaying them.

	$TheDVDTitle = $db->sql_escape($dvd_info['TITLE'][0]['VALUE']);
	$f  = 'id';				$v  = "'$TheProfileID'";
	$f .= ',upc';				$v .= ",'" . $dvd_info['UPC'][0]['VALUE'] . "'";
	$f .= ',mediatypedvd';			$v .= ','  . TrueFalse($dvd_info['MEDIATYPES'][0]['DVD'][0]['VALUE']);
	$f .= ',mediatypehddvd';		$v .= ','  . TrueFalse($dvd_info['MEDIATYPES'][0]['HDDVD'][0]['VALUE']);
	$f .= ',mediatypebluray';		$v .= ','  . TrueFalse($dvd_info['MEDIATYPES'][0]['BLURAY'][0]['VALUE']);
	$f .= ',title';				$v .= ",'$TheDVDTitle'";
	$f .= ',sorttitle';			$v .= ",'" . StringIfThere($dvd_info['SORTTITLE'][0]['VALUE'], $TheDVDTitle) . "'";
	$f .= ',originaltitle';			$v .= ",'" . StringIfThere($dvd_info['ORIGINALTITLE'][0]['VALUE']) . "'";
	$f .= ',description';			$v .= ",'" . StringIfThere($dvd_info['DISTTRAIT'][0]['VALUE']) . "'";
	$f .= ',countryoforigin';		$v .= ",'" . StringIfThere($dvd_info['COUNTRYOFORIGIN'][0]['VALUE']) . "'";
	$f .= ',region';			$v .= ",'$region'";
	$f .= ',collectiontype';		$v .= ",'$collectiontype'";
	$f .= ',auxcolltype';			$v .= ",'" . $db->sql_escape($auxcolltype) . "'";
	$f .= ',collectionnumber';		$v .= ','  . (isset($dvd_info['COLLECTIONNUMBER'][0]['VALUE']) ? intval($dvd_info['COLLECTIONNUMBER'][0]['VALUE']) : 0);
	$f .= ',rating';			$v .= ",'" . (!empty($dvd_info['RATING'][0]['VALUE']) ? $db->sql_escape($dvd_info['RATING'][0]['VALUE']) : 'NR') . "'";
	$f .= ',ratingsystem';			$v .= ",'" . (!empty($dvd_info['RATINGSYSTEM'][0]['VALUE']) ? $db->sql_escape($dvd_info['RATINGSYSTEM'][0]['VALUE']) : '') . "'";
	$f .= ',ratingage';			$v .= ",'" . (!empty($dvd_info['RATINGAGE'][0]['VALUE']) ? $db->sql_escape($dvd_info['RATINGAGE'][0]['VALUE']) : '') . "'";
	$f .= ',ratingvariant';			$v .= ",'" . (!empty($dvd_info['RATINGVARIANT'][0]['VALUE']) ? $db->sql_escape($dvd_info['RATINGVARIANT'][0]['VALUE']) : '') . "'";
	$f .= ',ratingdetails';			$v .= ",'" . (!empty($dvd_info['RATINGDETAILS'][0]['VALUE']) ? $db->sql_escape($dvd_info['RATINGDETAILS'][0]['VALUE']) : '') . "'";
	$f .= ',productionyear';		$v .= ",'" . StringIfThere($dvd_info['PRODUCTIONYEAR'][0]['VALUE']) . "'";
	$f .= ',released';			$v .= ",$released";
	$f .= ',runningtime';			$v .= ','  . (isset($dvd_info['RUNNINGTIME'][0]['VALUE']) ? $dvd_info['RUNNINGTIME'][0]['VALUE'] : 0);
	$f .= ',casetype';			$v .= ",'" . (!empty($dvd_info['CASETYPE'][0]['VALUE']) ? $dvd_info['CASETYPE'][0]['VALUE'] : 'Unknown') . "'";
	$f .= ',caseslipcover';			$v .= ','  . $caseslipcover;
	$f .= ',isadulttitle';			$v .= ','  . $isadulttitle;

	$f .= ',formatvideostandard';		$v .= ",'" . StringIfThere($dvd_info['FORMAT'][0]['FORMATVIDEOSTANDARD'][0]['VALUE']) . "'";
	$f .= ',formatletterbox';		$v .= ',' . $formatletterbox;
	$f .= ',format16x9';			$v .= ',' . $format16x9;
	$f .= ',formataspectratio';		$v .= ",'$formataspectratio'";
	$f .= ',formatpanandscan';		$v .= ','  . TrueFalse($dvd_info['FORMAT'][0]['FORMATPANANDSCAN'][0]['VALUE']);
	$f .= ',formatfullframe';		$v .= ','  . TrueFalse($dvd_info['FORMAT'][0]['FORMATFULLFRAME'][0]['VALUE']);
	$f .= ',formatdualsided';		$v .= ','  . TrueFalse($dvd_info['FORMAT'][0]['FORMATDUALSIDED'][0]['VALUE']);
	$f .= ',formatduallayered';		$v .= ','  . TrueFalse($dvd_info['FORMAT'][0]['FORMATDUALLAYERED'][0]['VALUE']);

	$f .= ',featuresceneaccess';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATURESCENEACCESS'][0]['VALUE']);
	$f .= ',featurecommentary';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATURECOMMENTARY'][0]['VALUE']);
	$f .= ',featuretrailer';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATURETRAILER'][0]['VALUE']);
	$f .= ',featurephotogallery';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREPHOTOGALLERY'][0]['VALUE']);
	$f .= ',featuredeletedscenes';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREDELETEDSCENES'][0]['VALUE']);
	$f .= ',featuremakingof';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREMAKINGOF'][0]['VALUE']);
	$f .= ',featureproductionnotes';	$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREPRODUCTIONNOTES'][0]['VALUE']);
	$f .= ',featuregame';			$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREGAME'][0]['VALUE']);
	$f .= ',featuredvdromcontent';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREDVDROMCONTENT'][0]['VALUE']);
	$f .= ',featuremultiangle';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREMULTIANGLE'][0]['VALUE']);
	$f .= ',featuremusicvideos';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREMUSICVIDEOS'][0]['VALUE']);
	$f .= ',featureinterviews';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREINTERVIEWS'][0]['VALUE']);
	$f .= ',featurestoryboardcomparisons';	$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATURESTORYBOARDCOMPARISONS'][0]['VALUE']);
	$f .= ',featureouttakes';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATUREOUTTAKES'][0]['VALUE']);
	$f .= ',featureclosedcaptioned';	$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATURECLOSEDCAPTIONED'][0]['VALUE']);
	$f .= ',featurethxcertified';		$v .= ','  . TrueFalse($dvd_info['FEATURES'][0]['FEATURETHXCERTIFIED'][0]['VALUE']);
	$f .= ',featureother';			$v .= ",'" . StringIfThere($dvd_info['FEATURES'][0]['OTHERFEATURES'][0]['VALUE']) . "'";

	$f .= ',reviewfilm';			$v .= ','  . $dvd_info['REVIEW'][0]['ATTRIBUTES']['FILM'];
	$f .= ',reviewvideo';			$v .= ','  . $dvd_info['REVIEW'][0]['ATTRIBUTES']['VIDEO'];
	$f .= ',reviewaudio';			$v .= ','  . $dvd_info['REVIEW'][0]['ATTRIBUTES']['AUDIO'];
	$f .= ',reviewextras';			$v .= ','  . $dvd_info['REVIEW'][0]['ATTRIBUTES']['EXTRAS'];

	$f .= ',srp';				$v .= ",'$srp'";
	$f .= ',srpcurrencyid';			$v .= ",'" . StringIfThere($dvd_info['SRP'][0]['ATTRIBUTES']['DENOMINATIONTYPE']) . "'";
	$f .= ',srpcurrencyname';		$v .= ",'" . StringIfThere($dvd_info['SRP'][0]['ATTRIBUTES']['DENOMINATIONDESC']) . "'";
	$f .= ',srpdec';			$v .= ",'$srpdec'";
	$f .= ',purchaseprice';			$v .= ",'$purchaseprice'";
	$f .= ',purchasepricecurrencyid';	$v .= ",'" . StringIfThere($dvd_info['PURCHASEINFO'][0]['PURCHASEPRICE'][0]['ATTRIBUTES']['DENOMINATIONTYPE']) . "'";
	$f .= ',purchasepricecurrencyname';	$v .= ",'" . StringIfThere($dvd_info['PURCHASEINFO'][0]['PURCHASEPRICE'][0]['ATTRIBUTES']['DENOMINATIONDESC']) . "'";
	$f .= ',paid';				$v .= ",'$paid'";
	$f .= ',purchasedate';			$v .= ','  . ($wishpriority==0 ? my_mktime(0, 0, 0, $purchase_month, $purchase_day, $purchase_year) : 0);
	$f .= ',purchaseplace';			$v .= ','  . $sid;

	$f .= ',notes';				$v .= ",'" . $db->sql_escape($notes) . "'";
	$f .= ',wishpriority';			$v .= ','  . $wishpriority;
	$f .= ',loaninfo';			$v .= ",'" . (TrueFalse($dvd_info['LOANINFO'][0]['LOANED'][0]['VALUE']) ? $dvd_info['LOANINFO'][0]['USER'][0]['ATTRIBUTES']['FIRSTNAME'] . ' ' . $dvd_info['LOANINFO'][0]['USER'][0]['ATTRIBUTES']['LASTNAME'] : '') . "'";
	$f .= ',loandue';			$v .= ','  . ($loan_year!=0 ? my_mktime(0, 0, 0, $loan_month, $loan_day, $loan_year) : 0);
	$f .= ',overview';			$v .= ",'" . StringIfThere($dvd_info['OVERVIEW'][0]['VALUE']) . "'";
	$f .= ',eastereggs';			$v .= ",'" . StringIfThere($dvd_info['EASTEREGGS'][0]['VALUE']) . "'";
	$f .= ',primegenre';			$v .= ",'" . $db->sql_escape($primegenre) . "'";
	$f .= ',boxparent';			$v .= ",''"; 
	$f .= ',boxchild';			$v .= ','  . (isset($dvd_info['BOXSET'][0]['CONTENTS'][0]['CONTENT'][0]['VALUE']) ? 1 : 0);
	$f .= ',hashprofile';			$v .= ",'$hashs[hashprofile]'";
	$f .= ',hashnocolid';			$v .= ",'$hashs[hashnocolid]'";
	$f .= ',hashcast';			$v .= ",'$hashs[hashcast]'";
	$f .= ',hashcrew';			$v .= ",'$hashs[hashcrew]'";
	$f .= ',lastedited';			$v .=','   . my_mktime(0, 0, 0, $lastedited_month, $lastedited_day, $lastedited_year);

	$db->sql_query("INSERT INTO $DVD_TABLE ($f) VALUES ($v)") or die($db->sql_error());
	return(0);
}

// This routine will not catch the case where a boxset child has been added to a pre-existing boxset
function UpdateBoxSets() {
global $db, $lang, $eoln, $showbadboxsetnames, $DVD_TABLE, $DVD_BOXSET_TABLE, $MadeAChange, $force_cleanup;

	if (!$MadeAChange && !$force_cleanup)
		return;
	$numbadentries = 0;
	$numbadsets = 0;
	$lastbadparent = '';

// Find and remove BoxSet entries where the child id isn't in the main table
 	$result = $db->sql_query("SELECT * FROM $DVD_BOXSET_TABLE ORDER BY id") or die($db->sql_error());
 	while ($pair = $db->sql_fetchrow($result)) {
 		$result1 = $db->sql_query("SELECT COUNT(*) AS numentries FROM $DVD_TABLE WHERE id='$pair[child]'") or die($db->sql_error());
 		$answer = $db->sql_fetchrow($result1);
 		$db->sql_freeresult($result1);
 		if ($answer['numentries'] == 0) {
 			$db->sql_query("DELETE FROM $DVD_BOXSET_TABLE WHERE id='$pair[id]' AND child='$pair[child]'") or die($db->sql_error());
			$numbadentries++;
			if ($lastbadparent != $pair['id']) {
				$lastbadparent = $pair['id'];
				$numbadsets++;
				if ($showbadboxsetnames) {
 					$result1 = $db->sql_query("SELECT title FROM $DVD_TABLE WHERE id='$lastbadparent'") or die($db->sql_error());
 					$answer = $db->sql_fetchrow($result1);
 					$db->sql_freeresult($result1);
					if ($numbadsets == 1)
						echo $lang['IMPORTBADBOXDESC'], $eoln;
					echo "$lang[IMPORTBADBOX]$answer[title] ($lastbadparent)$eoln";
				}
			}
 		}
 	}
	if ($numbadentries > 0) {
		echo $lang['IMPORTENTRIES'], $numbadentries, $eoln;
		echo $lang['IMPORTCOLLECTIONS'], $numbadsets, $eoln;
	}

// Update the main table to set the child's parentpointer
	$result = $db->sql_query("SELECT * FROM $DVD_BOXSET_TABLE") or die($db->sql_error());
	while ($pair = $db->sql_fetchrow($result)) {
		$db->sql_query("UPDATE $DVD_TABLE SET boxparent='$pair[id]' WHERE id='$pair[child]'") or die($db->sql_error());
	}
	$db->sql_freeresult($result);

// Update the main table so that the box child member reflects the number of children
	$result = $db->sql_query("SELECT DISTINCT id FROM $DVD_BOXSET_TABLE") or die($db->sql_error());
	while ($pair = $db->sql_fetchrow($result)) {
		$parent = $pair['id'];
		$numkids = 0;
		$result1 = $db->sql_query("SELECT COUNT(*) AS numkids FROM $DVD_TABLE d,$DVD_BOXSET_TABLE b WHERE d.id=b.child and b.id='$parent'") or die($db->sql_error());
		$answer = $db->sql_fetchrow($result1);
		$db->sql_freeresult($result1);

		$db->sql_query("UPDATE $DVD_TABLE SET boxchild=$answer[numkids] WHERE id='$parent'") or die($db->sql_error());
	}
	$db->sql_freeresult($result);
}

function UpdateStats($TryToChangeMemoryAndTimeLimits) {
global $DVD_TABLE, $DVD_STATS_TABLE, $DVD_ACTOR_TABLE, $DVD_CREDITS_TABLE, $DVD_AUDIO_TABLE, $DVD_PROPERTIES_TABLE;
global $lang, $db, $MaxX, $MadeAChange, $inbrowser, $eoln, $ProfileStatistics, $force_cleanup;
global $usetemptable, $shortestspecialcondition, $runtimespecialcondition, $regionspecialcondition;
global $audiospecialcondition;

	if (!$MadeAChange && !$force_cleanup)
		return;
	$db->sql_query("DELETE FROM $DVD_STATS_TABLE") or die($db->sql_error());
	$noadulttitles = false;
	if (TableCopyingSupported()) {
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$result = $db->sql_query("SELECT COUNT(*) AS num FROM $DVD_TABLE WHERE isadulttitle=1") or die($db->sql_error());
		$answer = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		$noadulttitles = $answer['num'] == 0;
		unset($answer);
	}

	$t0 = microtime_float(); $numtimings = 0;
// Create tables including and excluding Adult titles

	$result = $db->sql_query("SELECT DISTINCT auxcolltype FROM $DVD_TABLE") or die($db->sql_error());
	$masterauxcolltype = '';
	while ($row = $db->sql_fetchrow($result)) {
		if ($masterauxcolltype != '') $masterauxcolltype .= ',';
		$masterauxcolltype = $masterauxcolltype . $row['auxcolltype'];
	}
	$db->sql_freeresult($result);
	$temparray = array_unique(explode(',', $masterauxcolltype));
	sort($temparray);
	$masterauxcolltype = implode(',', $temparray);
	unset($temparray);
	$result = $db->sql_query("SELECT value FROM $DVD_PROPERTIES_TABLE WHERE property='masterauxcolltypeNoAdult'") or die($db->sql_error());
	$answer = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	if ($answer === false) {
		$sql = "INSERT INTO $DVD_PROPERTIES_TABLE SET value='".addslashes($masterauxcolltype)."', property='masterauxcolltypeNoAdult'";
	}
	else {
		$sql = "UPDATE $DVD_PROPERTIES_TABLE SET value='".addslashes($masterauxcolltype)."' WHERE property='masterauxcolltypeNoAdult'";
	}
	$db->sql_query($sql) or die($db->sql_error());
	unset($answer);
	$ProfileName[$numtimings] = 'AuxilliaryCollectionsAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

	if ($noadulttitles) {
		$result = $db->sql_query("SELECT value FROM $DVD_PROPERTIES_TABLE WHERE property='masterauxcolltypeAdult'") or die($db->sql_error());
		$answer = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		if ($answer === false) {
			$sql = "INSERT INTO $DVD_PROPERTIES_TABLE SET value='".addslashes($masterauxcolltype)."', property='masterauxcolltypeAdult'";
		}
		else {
			$sql = "UPDATE $DVD_PROPERTIES_TABLE SET value='".addslashes($masterauxcolltype)."' WHERE property='masterauxcolltypeAdult'";
		}
		$db->sql_query($sql) or die($db->sql_error());
		unset($answer);
	}
	else {
		$result = $db->sql_query("SELECT DISTINCT auxcolltype FROM $DVD_TABLE WHERE isadulttitle=0") or die($db->sql_error());
		$masterauxcolltype = '';
		while ($row = $db->sql_fetchrow($result)) {
			if ($masterauxcolltype != '') $masterauxcolltype .= ',';
			$masterauxcolltype = $masterauxcolltype . $row['auxcolltype'];
		}
		$db->sql_freeresult($result);
		$temparray = array_unique(explode(',', $masterauxcolltype));
		sort($temparray);
		$masterauxcolltype = implode(',', $temparray);
		unset($temparray);
		$result = $db->sql_query("SELECT value FROM $DVD_PROPERTIES_TABLE WHERE property='masterauxcolltypeAdult'") or die($db->sql_error());
		$answer = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		if ($answer === false) {
			$sql = "INSERT INTO $DVD_PROPERTIES_TABLE SET value='".addslashes($masterauxcolltype)."', property='masterauxcolltypeAdult'";
		}
		else {
			$sql = "UPDATE $DVD_PROPERTIES_TABLE SET value='".addslashes($masterauxcolltype)."' WHERE property='masterauxcolltypeAdult'";
		}
		$db->sql_query($sql) or die($db->sql_error());
		unset($answer);
	}
	$ProfileName[$numtimings] = 'AuxilliaryCollectionsNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
	if ($noadulttitles) $numtimings--;

// Profile totals per region (ie. number of discs playable in region 2) including Adult titles
	for ($i=0; $i<10; $i++) {
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'RegionAdult','$i','','',COUNT(*) AS total FROM $DVD_TABLE "
			."WHERE region LIKE '%$i%' AND collectiontype='owned' $regionspecialcondition";
		$result = $db->sql_query($sql) or die($db->sql_error());
		$dvd = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
	}
	$ProfileName[$numtimings] = 'RegionStatsAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// Profile totals per region (ie. number of discs playable in region 2) including Adult titles
	if ($noadulttitles) {
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'RegionNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
			."WHERE stattype='RegionAdult'";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
	}
	else {
		for ($i=0; $i<10; $i++) {
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'RegionNoAdult','$i','','',COUNT(*) AS total FROM $DVD_TABLE "
				."WHERE region LIKE '%$i%' AND collectiontype='owned' AND isadulttitle=0 $regionspecialcondition";
			$result = $db->sql_query($sql) or die($db->sql_error());
			$dvd = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);
		}
	}
	$ProfileName[$numtimings] = 'RegionStatsNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
	if ($noadulttitles) $numtimings--;

// Number of profiles per Audio Format including Adult titles
	$sql = "INSERT INTO $DVD_STATS_TABLE "
		."SELECT 'AudioFormatAdult',audioformat,'','',COUNT(*) AS total FROM $DVD_AUDIO_TABLE a, $DVD_TABLE d "
		."WHERE d.id=a.id AND collectiontype='owned' $audiospecialcondition "
		."GROUP BY audioformat ORDER BY total DESC";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'AudioFormatAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// Number of profiles per Audio Format excluding Adult titles
	if ($noadulttitles) 
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'AudioFormatNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
			."WHERE stattype='AudioFormatAdult'";
	else
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'AudioFormatNoAdult',audioformat,'','',COUNT(*) AS total FROM $DVD_AUDIO_TABLE a, $DVD_TABLE d "
			."WHERE d.id=a.id AND collectiontype='owned' AND isadulttitle=0 $audiospecialcondition "
			."GROUP BY audioformat ORDER BY total DESC";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'AudioFormatNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
	if ($noadulttitles) $numtimings--;

// $MaxX profiles with longest running time including Adult titles
	$sql = "INSERT INTO $DVD_STATS_TABLE "
		."SELECT 'LongTimeAdult',title,sorttitle,id,runningtime FROM $DVD_TABLE "
		."WHERE collectiontype='owned' $runtimespecialcondition "
		."ORDER BY runningtime DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'LongTimeAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX profiles with longest running time excluding Adult titles
	if ($noadulttitles) 
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'LongTimeNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
			."WHERE stattype='LongTimeAdult'";
	else
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'LongTimeNoAdult',title,sorttitle,id,runningtime FROM $DVD_TABLE "
			."WHERE collectiontype='owned' AND isadulttitle=0 $runtimespecialcondition "
			."ORDER BY runningtime DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'LongTimeNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
	if ($noadulttitles) $numtimings--;

// $MaxX profiles with shortest running time including Adult titles
	$sql = "INSERT INTO $DVD_STATS_TABLE "
		."SELECT 'ShortTimeAdult',title,sorttitle,id,runningtime FROM $DVD_TABLE "
		."WHERE collectiontype='owned' $shortestspecialcondition "
		."ORDER BY runningtime ASC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'ShortTimeAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX profiles with shortest running time excluding Adult titles
	if ($noadulttitles)
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'ShortTimeNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
			."WHERE stattype='ShortTimeAdult'";
	else
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'ShortTimeNoAdult',title,sorttitle,id,runningtime FROM $DVD_TABLE "
			."WHERE collectiontype='owned' AND isadulttitle=0 $shortestspecialcondition "
			."ORDER BY runningtime ASC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'ShortTimeNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
	if ($noadulttitles) $numtimings--;

	if ($usetemptable) {
		$sql = "CREATE TEMPORARY TABLE TEMP_ACTORS ("
			."id char(20) NOT NULL, "
			."caid int, "
			."voice tinyint(1) unsigned, "
			."uncredited tinyint(1) unsigned, "
			."boxparent varchar(20), "
			."isadulttitle tinyint(1), "
			."KEY(id), KEY(caid)"
			.") TYPE=MyISAM;";
		$db->sql_query($sql) or die($db->sql_error());
// this needs to be looked at
		$sql = "INSERT IGNORE INTO TEMP_ACTORS SELECT a.id,caid,voice,uncredited,boxparent,isadulttitle FROM $DVD_ACTOR_TABLE a,$DVD_TABLE d "
			."WHERE a.id=d.id AND caid!=1 AND collectiontype='owned'";
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'Actors Setup'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Actors including Adult titles
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'ActorsAdult',caid,'','',COUNT(DISTINCT(id)) AS times FROM TEMP_ACTORS "
			."GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'ActorsAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Actors excluding Adult titles
		if ($noadulttitles)
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'ActorsNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
				."WHERE stattype='ActorsAdult'";
		else
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'ActorsNoAdult',caid,'','',COUNT(DISTINCT(id)) AS times FROM TEMP_ACTORS "
				."WHERE isadulttitle=0 "
				."GROUP BY caid "
				."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'ActorsNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
		if ($noadulttitles) $numtimings--;

// $MaxX most collected Actors including Adult titles excluding voice-only parts
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'ActorsNVAdult',caid,'','',COUNT(DISTINCT(id)) AS times FROM TEMP_ACTORS "
			."WHERE voice=0 GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'ActorsNVAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Actors excluding Adult titles excluding voice-only parts
		if ($noadulttitles)
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'ActorsNVNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
				."WHERE stattype='ActorsNVAdult'";
		else
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'ActorsNVNoAdult',caid,'','',COUNT(DISTINCT(id)) AS times FROM TEMP_ACTORS "
				."WHERE isadulttitle=0 AND voice=0 "
				."GROUP BY caid "
				."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'ActorsNVNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
		if ($noadulttitles) $numtimings--;
/*********************************
// $MaxX most collected Actors counting BoxSets as 1 including Adult titles
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'NormActorsAdult',caid,'','',COUNT(DISTINCT(id)) AS times FROM TEMP_ACTORS "
			."WHERE boxparent='' GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'NormActorsAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Actors counting BoxSets as 1 excluding Adult titles
		if ($noadulttitles)
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'NormActorsNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
				."WHERE stattype='NormActorsAdult'";
		else
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'NormActorsNoAdult',caid,'','',COUNT(DISTINCT(id)) AS times FROM TEMP_ACTORS "
				."WHERE boxparent='' AND isadulttitle=0 GROUP BY caid "
				."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'NormActorsNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
		if ($noadulttitles) $numtimings--;

// $MaxX most collected Actors counting BoxSets as 1 including Adult titles excluding voice-only parts
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'NormActorsNVAdult',caid,'','',COUNT(DISTINCT(id)) AS times FROM TEMP_ACTORS "
			."WHERE boxparent='' AND voice=0 GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'NormActorsNVAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Actors counting BoxSets as 1 excluding Adult titles excluding voice-only parts
		if ($noadulttitles)
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'NormActorsNVNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
				."WHERE stattype='NormActorsNVAdult'";
		else
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'NormActorsNVNoAdult',caid,'','',COUNT(DISTINCT(id)) AS times FROM TEMP_ACTORS "
				."WHERE boxparent='' AND voice=0 AND isadulttitle=0 GROUP BY caid "
				."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'NormActorsNVNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
		if ($noadulttitles) $numtimings--;
****************************/
	}
	else {
// $MaxX most collected Actors including Adult titles
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'ActorsAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_ACTOR_TABLE a,$DVD_TABLE d "
			."WHERE a.id=d.id AND caid!=1 AND collectiontype='owned' GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'ActorsAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Actors excluding Adult titles
		if ($noadulttitles)
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'ActorsNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
				."WHERE stattype='ActorsAdult'";
		else
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'ActorsNoAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_ACTOR_TABLE a,$DVD_TABLE d "
				."WHERE a.id=d.id AND caid!=1 AND collectiontype='owned' AND isadulttitle=0 "
				."GROUP BY caid "
				."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'ActorsNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
		if ($noadulttitles) $numtimings--;

// $MaxX most collected Actors including Adult titles excluding voice-only parts
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'ActorsNVAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_ACTOR_TABLE a,$DVD_TABLE d "
			."WHERE a.id=d.id AND caid!=1 AND collectiontype='owned' AND voice=0 GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'ActorsNVAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Actors excluding Adult titles excluding voice-only parts
		if ($noadulttitles)
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'ActorsNVNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
				."WHERE stattype='ActorsNVAdult'";
		else
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'ActorsNVNoAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_ACTOR_TABLE a,$DVD_TABLE d "
				."WHERE a.id=d.id AND caid!=1 AND collectiontype='owned' AND voice=0 AND isadulttitle=0 "
				."GROUP BY caid "
				."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'ActorsNVNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
		if ($noadulttitles) $numtimings--;

/************************************
// $MaxX most collected Actors counting BoxSets as 1 including Adult titles
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'NormActorsAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_ACTOR_TABLE a,$DVD_TABLE d "
			."WHERE boxparent='' AND a.id=d.id AND caid!=1 AND collectiontype='owned' GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'NormActorsAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Actors counting BoxSets as 1 excluding Adult titles
		if ($noadulttitles)
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'NormActorsNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
				."WHERE stattype='NormActorsAdult'";
		else
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'NormActorsNoAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_ACTOR_TABLE a,$DVD_TABLE d "
				."WHERE boxparent='' AND a.id=d.id AND caid!=1 AND collectiontype='owned' AND isadulttitle=0 GROUP BY caid "
				."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'NormActorsNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
		if ($noadulttitles) $numtimings--;

// $MaxX most collected Actors counting BoxSets as 1 including Adult titles excluding voice-only parts
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'NormActorsNVAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_ACTOR_TABLE a,$DVD_TABLE d "
			."WHERE boxparent='' AND a.id=d.id AND caid!=1 AND voice=0 AND collectiontype='owned' GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'NormActorsNVAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Actors counting BoxSets as 1 excluding Adult titles excluding voice-only parts
		if ($noadulttitles)
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'NormActorsNVNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
				."WHERE stattype='NormActorsNVAdult'";
		else
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'NormActorsNVNoAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_ACTOR_TABLE a,$DVD_TABLE d "
				."WHERE boxparent='' AND a.id=d.id AND caid!=1 AND voice=0 AND collectiontype='owned' AND isadulttitle=0 GROUP BY caid "
				."ORDER BY times DESC LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = 'NormActorsNVNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
		if ($noadulttitles) $numtimings--;
********************************/
	}

// $MaxX most collected Directors including Adult titles
	$sql = "INSERT INTO $DVD_STATS_TABLE "
		."SELECT 'DirectorsAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_CREDITS_TABLE a,$DVD_TABLE d "
		."WHERE a.id=d.id AND collectiontype='owned' AND credittype='direction' GROUP BY caid "
		."ORDER BY times DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'DirectorsAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Directors excluding Adult titles
	if ($noadulttitles)
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'DirectorsNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
			."WHERE stattype='DirectorsAdult'";
	else
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'DirectorsNoAdult',caid,'','',COUNT(DISTINCT(c.id)) AS times FROM $DVD_CREDITS_TABLE c,$DVD_TABLE d "
			."WHERE d.id=c.id AND collectiontype='owned' AND credittype='direction' AND "
			."isadulttitle=0 GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'DirectorsNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
	if ($noadulttitles) $numtimings--;
/*************************************
// $MaxX most collected Directors counting BoxSets as 1 including Adult titles
	$sql = "INSERT INTO $DVD_STATS_TABLE "
		."SELECT 'NormDirectorsAdult',caid,'','',COUNT(DISTINCT(c.id)) AS times FROM $DVD_CREDITS_TABLE c,$DVD_TABLE d "
		."WHERE boxparent='' AND d.id=c.id AND collectiontype='owned' AND credittype='direction' "
		."GROUP BY caid "
		."ORDER BY times DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'NormDirectorsAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Directors counting BoxSets as 1 excluding Adult titles
	if ($noadulttitles)
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'NormDirectorsNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
			."WHERE stattype='NormDirectorsAdult'";
	else
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'NormDirectorsNoAdult',caid,'','',COUNT(DISTINCT(c.id)) AS times FROM $DVD_CREDITS_TABLE c,$DVD_TABLE d "
			."WHERE boxparent='' AND d.id=c.id AND collectiontype='owned' AND credittype='direction' "
			."AND isadulttitle=0 GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'NormDirectorsNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
	if ($noadulttitles) $numtimings--;
**************************************/

// $MaxX most collected Writers including Adult titles
	$sql = "INSERT INTO $DVD_STATS_TABLE "
		."SELECT 'WritersAdult',caid,'','',COUNT(DISTINCT(a.id)) AS times FROM $DVD_CREDITS_TABLE a,$DVD_TABLE d "
		."WHERE a.id=d.id AND collectiontype='owned' AND credittype='writing' GROUP BY caid "
		."ORDER BY times DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'WritersAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Writers excluding Adult titles
	if ($noadulttitles)
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'WritersNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
			."WHERE stattype='WritersAdult'";
	else
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'WritersNoAdult',caid,'','',COUNT(DISTINCT(c.id)) AS times FROM $DVD_CREDITS_TABLE c,$DVD_TABLE d "
			."WHERE d.id=c.id AND collectiontype='owned' AND credittype='writing' AND "
			."isadulttitle=0 GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'WritersNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
	if ($noadulttitles) $numtimings--;
/****************************************
// $MaxX most collected Writers counting BoxSets as 1 including Adult titles
	$sql = "INSERT INTO $DVD_STATS_TABLE "
		."SELECT 'NormWritersAdult',caid,'','',COUNT(DISTINCT(c.id)) AS times FROM $DVD_CREDITS_TABLE c,$DVD_TABLE d "
		."WHERE boxparent='' AND c.id=d.id AND collectiontype='owned' AND credittype='writing' "
		."GROUP BY caid "
		."ORDER BY times DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'NormWritersAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most collected Writers counting BoxSets as 1 excluding Adult titles
	if ($noadulttitles)
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'NormWritersNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
			."WHERE stattype='NormWritersAdult'";
	else
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'NormWritersNoAdult',caid,'','',COUNT(DISTINCT(c.id)) AS times FROM $DVD_CREDITS_TABLE c,$DVD_TABLE d "
			."WHERE boxparent='' AND c.id=d.id AND collectiontype='owned' AND credittype='writing' "
			."AND isadulttitle=0 GROUP BY caid "
			."ORDER BY times DESC LIMIT $MaxX";
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$db->sql_query($sql) or die($db->sql_error());
	$ProfileName[$numtimings] = 'NormWritersNoAdult'; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
	if ($noadulttitles) $numtimings--;
*************************************/
// $MaxX most expensive DVDs including Adult titles
// *****NOTE*****
//   This is just selecting the largest values from the 'paid' column, which are not guaranteed to all be in the
//   same currency. If they are not, then these results are incorrect. A more correct way to do this is once for
//   each of the currencies paid ... a fair bit of work i'm not interested in doing at the moment
	if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
	$result = $db->sql_query("SELECT DISTINCT purchasepricecurrencyid AS ppci FROM $DVD_TABLE WHERE collectiontype='owned'") or die($db->sql_error());
	while ($ppcis = $db->sql_fetchrow($result)) {
		$sql = "INSERT INTO $DVD_STATS_TABLE "
			."SELECT 'PricePaidAdult',title,purchasepricecurrencyid,id,paid*1000 FROM $DVD_TABLE "
			."WHERE collectiontype='owned' AND purchasepricecurrencyid='$ppcis[ppci]' "
			."ORDER BY paid DESC,sorttitle LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = "PricePaidAdult$ppcis[ppci]"; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();

// $MaxX most expensive DVDs excluding Adult titles
		if ($noadulttitles)
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'PricePaidNoAdult',namestring1,namestring2,id,counts FROM $DVD_STATS_TABLE "
				."WHERE stattype='PricePaidAdult$ppcis[ppci]'";
		else
			$sql = "INSERT INTO $DVD_STATS_TABLE "
				."SELECT 'PricePaidNoAdult',title,purchasepricecurrencyid,id,paid*1000 FROM $DVD_TABLE "
				."WHERE collectiontype='owned' AND purchasepricecurrencyid='$ppcis[ppci]' "
				."AND isadulttitle=0 "
				."ORDER BY paid DESC,sorttitle LIMIT $MaxX";
		if ($TryToChangeMemoryAndTimeLimits) set_time_limit(0);
		$db->sql_query($sql) or die($db->sql_error());
		$ProfileName[$numtimings] = "PricePaidNoAdult$ppcis[ppci]"; $Profile[$numtimings++] = microtime_float()-$t0; $t0 = microtime_float();
		if ($noadulttitles) $numtimings--;
	}
	$db->sql_freeresult($result);

	if ($ProfileStatistics) {
		if ($inbrowser) echo "<pre>";
		echo "Timings:\n";
		$totaltime = 0;
		for ($i=0; $i<$numtimings; $i++) {
			$totaltime += $Profile[$i];
			printf("  %-30s %7s\n", $ProfileName[$i], number_format($Profile[$i], 3, $lang['MON_DECIMAL_POINT'], $lang['MON_THOUSANDS_SEP']));
		}
		echo "Total Time: ", number_format($totaltime, 3, $lang['MON_DECIMAL_POINT'], $lang['MON_THOUSANDS_SEP']), "\n";
		if ($inbrowser) echo "</pre>";
	}
	unset($ProfileName);
	unset($Profile);
}
?>
